package com.xkrs.service.impl;

import com.xkrs.common.encapsulation.PromptMessageEnum;
import com.xkrs.dao.SomeThingDao;
import com.xkrs.dao.StreetDao;
import com.xkrs.model.bean.RegionBean;
import com.xkrs.model.entity.SomeThingEntity;
import com.xkrs.model.entity.StreetEntity;
import com.xkrs.service.StreetService;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;

import static com.xkrs.common.encapsulation.OutputEncapsulation.outputEncapsulationObject;

@Service
public class StreetServiceImpl implements StreetService {

    private final Locale locale = LocaleContextHolder.getLocale();

    @Resource
    private StreetDao streetDao;

    @Resource
    private SomeThingDao someThingDao;


    @Override
    public List<StreetEntity> findByProName(String proName) {
        return streetDao.findByProName(proName);
    }

    @Override
    public List<StreetEntity> findByProCode(String proCode) {
        return streetDao.findByProCode(proCode);
    }

    @Override
    public List<StreetEntity> findByCityName(String cityName) {
        return streetDao.findByCityName(cityName);
    }

    @Override
    public List<StreetEntity> findByCityCode(String cityCode) {
        return streetDao.findByCityCode(cityCode);
    }

    @Override
    public List<StreetEntity> findByCountyName(String countyName) {
        return streetDao.findByCountyName(countyName);
    }

    @Override
    public List<StreetEntity> findByCountyCode(String countyCode) {
        return streetDao.findByCountyCode(countyCode);
    }

    @Override
    public List<StreetEntity> findByStreetName(String streetName) {
        return streetDao.findByStreetName(streetName);
    }

    @Override
    public List<StreetEntity> findByStreetCode(String streetCode) {
        return streetDao.findByStreetCode(streetCode);
    }

    @Override
    public List<Map<String, String>> selectProvinceList() {
        return streetDao.selectProvinceList();
    }

    @Override
    public List<Map<String, String>> selectCityList(String provinceCode) {
        return streetDao.selectCityList(provinceCode);
    }

    @Override
    public List<Map<String, String>> selectCountyList(String cityCode) {
        return streetDao.selectCountyList(cityCode);
    }

    @Override
    public List<Map<String, String>> selectStreetList(String countyCode) {
        return streetDao.selectStreetList(countyCode);
    }

    @Override
    public String getAllRegionList() {

        Optional<SomeThingEntity> targetOptional = someThingDao.findById(1L);
        return targetOptional.get().getContent();

//        List<Map<String, String>> provinceList = selectProvinceList();
//        List<RegionBean> provinceBeanList = new ArrayList<>();
//        for (Map<String, String> province : provinceList) {
//            RegionBean provinceBean = new RegionBean();
//            provinceBean.setCode(province.get("code"));
//            provinceBean.setName(province.get("name"));
//            List<Map<String, String>> cityList = selectCityList(province.get("code"));
//            List<RegionBean> cityBeanList = new ArrayList<>();
//            for (Map<String, String> city : cityList) {
//                RegionBean cityBean = new RegionBean();
//                cityBean.setCode(city.get("code"));
//                cityBean.setName(city.get("name"));
//                List<Map<String, String>> countyList = selectCountyList(city.get("code"));
//                List<RegionBean> countyBeanList = new ArrayList<>();
//                for (Map<String, String> county : countyList) {
//                    RegionBean countyBean = new RegionBean();
//                    countyBean.setCode(county.get("code"));
//                    countyBean.setName(county.get("name"));
////                    List<Map<String, String>> streetList = selectStreetList(county.get("name"));
////                    List<RegionBean> streetBeanList = new ArrayList<>();
////                    for (Map<String, String> street : streetList) {
////                        RegionBean streetBean = new RegionBean();
////                        streetBean.setCode(street.get("code"));
////                        streetBean.setName(street.get("name"));
////                        streetBeanList.add(streetBean);
////                    }
////                    countyBean.setChildren(streetBeanList);
//                    countyBeanList.add(countyBean);
//                }
//                cityBean.setChildren(countyBeanList);
//                cityBeanList.add(cityBean);
//            }
//            provinceBean.setChildren(cityBeanList);
//            provinceBeanList.add(provinceBean);
//        }
//        return outputEncapsulationObject(PromptMessageEnum.SUCCESS, provinceBeanList, locale);
    }

}
